const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Fee_structuresDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const fee_structures = await db.fee_structures.create(
      {
        id: data.id || undefined,

        term: data.term || null,
        amount: data.amount || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await fee_structures.setSchool(data.school || null, {
      transaction,
    });

    await fee_structures.setSchools(data.schools || null, {
      transaction,
    });

    return fee_structures;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const fee_structuresData = data.map((item, index) => ({
      id: item.id || undefined,

      term: item.term || null,
      amount: item.amount || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const fee_structures = await db.fee_structures.bulkCreate(
      fee_structuresData,
      { transaction },
    );

    // For each item created, replace relation files

    return fee_structures;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const fee_structures = await db.fee_structures.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.term !== undefined) updatePayload.term = data.term;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    updatePayload.updatedById = currentUser.id;

    await fee_structures.update(updatePayload, { transaction });

    if (data.school !== undefined) {
      await fee_structures.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await fee_structures.setSchools(
        data.schools,

        { transaction },
      );
    }

    return fee_structures;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const fee_structures = await db.fee_structures.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of fee_structures) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of fee_structures) {
        await record.destroy({ transaction });
      }
    });

    return fee_structures;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const fee_structures = await db.fee_structures.findByPk(id, options);

    await fee_structures.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await fee_structures.destroy({
      transaction,
    });

    return fee_structures;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const fee_structures = await db.fee_structures.findOne(
      { where },
      { transaction },
    );

    if (!fee_structures) {
      return fee_structures;
    }

    const output = fee_structures.get({ plain: true });

    output.school = await fee_structures.getSchool({
      transaction,
    });

    output.schools = await fee_structures.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.term) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('fee_structures', 'term', filter.term),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.fee_structures.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('fee_structures', 'term', query),
        ],
      };
    }

    const records = await db.fee_structures.findAll({
      attributes: ['id', 'term'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['term', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.term,
    }));
  }
};
